function demo2
% L170101

[y, fs, nbits] = wavread('sampsa.wav');
y = y - mean(y);
fprintf(1,'Seuraava nitiedosto on tutkija Sampsa Laineen lahja maailmalle...\n');
soundsc(y, fs);
pause;

pituus_sek = length(y)/fs;
t = linspace(0, pituus_sek, length(y));
plot(t,y);
title('sampsa.wav: a-nne');
xlabel('aika (sekunnit)');
ylabel('voimakkuus');
% Nytt varsin sekavalta - otetaan pieni nyte kymmenysosasekunnin 
% ajalta:
fprintf(1,'Nytt varsin sekavalta - otetaan pieni nyte...\n');
pause;

plot(t(1:4410),y(1:4410));
grid on;
title('sampsa.wav, t = 0..0.1 sek');
xlabel('aika (sekunnit)');
ylabel('voimakkuus');
% Signaali nytt lhes periodiselta eli x(t) = x(t+T). 
% Mik on sen "jaksonpituus" T?
fprintf(1,'Signaali nytt lhes periodiselta eli x(t) = x(t+T).\n');
fprintf(1,'Mik on sen "jaksonpituus" T?\n');
pause;

% Taajuustasoon fourier-muuntamalla ja sen spektri:
fprintf(1,'\n\nSignaaleja kannattaa tutkia niin aika- kuin taajuustasossa.\n');
fprintf(1,'Taajuustason tutkimiseen Fourier-muunnos on oiva tykalu.\n');
yF = fft(y);
hz = linspace(0,fs, length(yF));
plot(hz(1:8917), abs(yF(1:8917)));
grid on;
title('sampsa.wav, spektri f = 0..4000 Hz');
xlabel('taajuus (hertz eli 1/s)');
ylabel('amplitudi');
fprintf(1,'Jaksollisuus nkyy nyt piikkein spektriss!\n');
fprintf(1,'Arvioi ensimmisen piikin taajuus (perustaajuus)\n');
fprintf(1,'ja vertaa sit yll laskemaasi jaksonpituuteen T!\n');
pause;

% Poistetaan ensimmiset piikit ylipstsuodatuksella
fprintf(1,'\nSuodatetaan suurin osa pienist piikeist pois ylipstsuodatuksella\n');
pause;
% KOMMENTTI: ensimmiset peruskomponentit eivt vaikuttaneet juuri mitn,
%  onko energia sittenkin keskittynyt 2-3 kHz:iin?
Rs = 2*2200/fs;
Rp = 2*3000/fs;
[N,Wn] = ellipord(Rp, Rs, 1, 40);
[b,a] = ellip(N, 1, 40, Wn, 'high');
%freqz(b,a,1024,fs);
y2 = filter(b,a,y);

fprintf(1,'...ja kuunnellaan lopputulos\n');
%spektrist katoaa piikit
pause;

soundsc(y2, fs);
figure,clf,
plot(t(1200:1800),y(1200:1800),'b',t(1200:1800),y2(1200:1800),'r');
legend('Alkuperinen','Suodatettu');

YY=fft(y2);
plot(hz,abs(YY))